# Cinder

# cinder::DataSource Class Reference

`#include <DataSource.h>`

Inherited by cinder::DataSourceBuffer, cinder::DataSourcePath, and cinder::DataSourceUrl.

List of all members.

## Public Member Functions
virtual bool | isFilePath ()=0
virtual bool | isUrl ()=0
const std::string & | getFilePath ()
const Url & | getUrl ()
const std::string & | getFilePathHint ()
Buffer & | getBuffer ()
virtual IStreamRef | getStream ()=0
## Protected Member Functions
| DataSource (const std::string &aFilePath, const Url &aUrl)
virtual | ~DataSource ()
virtual void | createBuffer ()=0
void | setFilePathHint (const std::string &aFilePathHint)
## Protected Attributes
Buffer | mBuffer
std::string | mFilePath
std::string | mFilePathHint
Url | mUrl

## Constructor & Destructor Documentation

cinder::DataSource::DataSource | ( | const std::string & | aFilePath,
|  | const Url & | aUrl |
| ) |  |  | `[protected]`

virtual cinder::DataSource::~DataSource | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

virtual bool cinder::DataSource::isFilePath | ( |  | ) | `[pure virtual]`

Implemented in cinder::DataSourcePath, cinder::DataSourceUrl, and cinder::DataSourceBuffer.

virtual bool cinder::DataSource::isUrl | ( |  | ) | `[pure virtual]`

Implemented in cinder::DataSourcePath, cinder::DataSourceUrl, and cinder::DataSourceBuffer.

const std::string & cinder::DataSource::getFilePath | ( |  | ) |

const Url & cinder::DataSource::getUrl | ( |  | ) |

const std::string & cinder::DataSource::getFilePathHint | ( |  | ) |

Buffer & cinder::DataSource::getBuffer | ( |  | ) |

virtual IStreamRef cinder::DataSource::getStream | ( |  | ) | `[pure virtual]`

Implemented in cinder::DataSourcePath, cinder::DataSourceUrl, and cinder::DataSourceBuffer.

virtual void cinder::DataSource::createBuffer | ( |  | ) | `[protected, pure virtual]`

Implemented in cinder::DataSourcePath, cinder::DataSourceUrl, and cinder::DataSourceBuffer.

void cinder::DataSource::setFilePathHint | ( | const std::string & | aFilePathHint | ) | `[protected]`

## Member Data Documentation

Buffer cinder::DataSource::mBuffer`[protected]`

std::string cinder::DataSource::mFilePath`[protected]`

std::string cinder::DataSource::mFilePathHint`[protected]`

Url cinder::DataSource::mUrl`[protected]`

The documentation for this class was generated from the following files:

- include/cinder/DataSource.h
- src/cinder/DataSource.cpp